#include "CrouchRepro.h"
#include "CrouchCharMvtComponent.h"
#include "EngineGlobals.h"
#include "Engine.h"

UCrouchCharMvtComponent::UCrouchCharMvtComponent(const FObjectInitializer& PCIP) : Super(PCIP) {}

void UCrouchCharMvtComponent::TickComponent(float DeltaTime,enum ELevelTick TickType,FActorComponentTickFunction *ThisTickFunction)
{
	Super::TickComponent(DeltaTime,TickType,ThisTickFunction);

	ACharacter* character = GetCharacterOwner();
	if (character == nullptr)
		return;

	if (WantedStance != Stance)
	{
		if (character->GetCurrentMontage() != TransitionMontage) //done playing
		{
			GEngine->AddOnScreenDebugMessage(-1,10.0f,FColor::Blue,FString::Printf(TEXT("Actor '%s' %s AnimMontage %s finished"),
				*character->GetFName().ToString(),*FindObject<UEnum>(ANY_PACKAGE,TEXT("ENetRole"))->GetEnumText(character->Role).ToString(),
				*TransitionMontage->GetFName().ToString()));

			Stance = WantedStance;
			TransitionMontage = nullptr;
		}
		return;
	}

	ECharStance newStance = ECharStance::Standing;
	if (MovementMode == EMovementMode::MOVE_Walking)
	{
		if (IsCrouching())
			newStance = ECharStance::Crouching;
	}
	
	if (newStance != Stance)
	{
		WantedStance = newStance;
		if (Stance == ECharStance::Standing && newStance == ECharStance::Crouching)
			TransitionMontage = StandToCrouchMontage;
		else if (Stance == ECharStance::Crouching && newStance == ECharStance::Standing)
			TransitionMontage = CrouchToStandMontage;
		else
			TransitionMontage = nullptr;

		if (TransitionMontage != nullptr)
		{
			//if (CharacterOwner->Role >= ROLE_AutonomousProxy)
			{
				GEngine->AddOnScreenDebugMessage(-1,10.0f,FColor::Green,FString::Printf(TEXT("Actor '%s' %s Playing AnimMontage %s"),
					*character->GetFName().ToString(),*FindObject<UEnum>(ANY_PACKAGE,TEXT("ENetRole"))->GetEnumText(character->Role).ToString(),
					*TransitionMontage->GetFName().ToString()));

				character->PlayAnimMontage(TransitionMontage);
			}			
		}
		else //just transition immediately
		{
			Stance = WantedStance;
		}
	}
}
