#pragma once

#include "GameFramework/CharacterMovementComponent.h"
#include "CrouchCharMvtComponent.generated.h"

enum class ECharStance : uint8
{
	Standing,
	Crouching
};

UCLASS()
class UCrouchCharMvtComponent : public UCharacterMovementComponent
{
	GENERATED_UCLASS_BODY()

public:
	void TickComponent(float DeltaTime, enum ELevelTick TickType, FActorComponentTickFunction *ThisTickFunction) override;

	ECharStance Stance = ECharStance::Standing;
	ECharStance WantedStance = ECharStance::Standing;

	UPROPERTY(EditDefaultsOnly,BlueprintReadOnly,Category="Montages")
	UAnimMontage* StandToCrouchMontage = nullptr;
	UPROPERTY(EditDefaultsOnly,BlueprintReadOnly,Category="Montages")
	UAnimMontage* CrouchToStandMontage = nullptr;

	UPROPERTY(Transient)
	UAnimMontage* TransitionMontage;
};